- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

List of all members
ClpQuadraticObjective Class Reference

Quadratic Objective Class. More...

`#include <ClpQuadraticObjective.hpp>`

Inheritance diagram for ClpQuadraticObjective:
[legend]
Collaboration diagram for ClpQuadraticObjective:
[legend]

## Public Member Functions
Stuff
virtual double * | gradient (const ClpSimplex *model, const double *solution, double &offset, bool refresh, int includeLinear=2)
| Returns gradient. More...
virtual double | reducedGradient (ClpSimplex *model, double *region, bool useFeasibleCosts)
| Resize objective. More...
virtual double | stepLength (ClpSimplex *model, const double *solution, const double *change, double maximumTheta, double &currentObj, double &predictedObj, double &thetaObj)
| Returns step length which gives minimum of objective for solution + theta * change vector up to maximum theta. More...
virtual double | objectiveValue (const ClpSimplex *model, const double *solution) const
| Return objective value (without any ClpModel offset) (model may be NULL) More...
virtual void | resize (int newNumberColumns)
| Returns gradient. More...
virtual void | deleteSome (int numberToDelete, const int *which)
| Delete columns in objective. More...
virtual void | reallyScale (const double *columnScale)
| Scale objective. More...
virtual int | markNonlinear (char *which)
| Given a zeroed array sets nonlinear columns to 1. More...
Constructors and destructors
| ClpQuadraticObjective ()
| Default Constructor. More...
| ClpQuadraticObjective (const double *linearObjective, int numberColumns, const CoinBigIndex *start, const int *column, const double *element, int numberExtendedColumns_=-1)
| Constructor from objective. More...
| ClpQuadraticObjective (const ClpQuadraticObjective &rhs, int type=0)
| Copy constructor . More...
| ClpQuadraticObjective (const ClpQuadraticObjective &rhs, int numberColumns, const int *whichColumns)
| Subset constructor. More...
ClpQuadraticObjective & | operator= (const ClpQuadraticObjective &rhs)
| Assignment operator. More...
virtual | ~ClpQuadraticObjective ()
| Destructor. More...
virtual ClpObjective * | clone () const
| Clone. More...
virtual ClpObjective * | subsetClone (int numberColumns, const int *whichColumns) const
| Subset clone. More...
void | loadQuadraticObjective (const int numberColumns, const CoinBigIndex *start, const int *column, const double *element, int numberExtendedColumns=-1)
| Load up quadratic objective. More...
void | loadQuadraticObjective (const CoinPackedMatrix &matrix)
| Default Constructor. More...
void | deleteQuadraticObjective ()
| Get rid of quadratic objective. More...
Gets and sets
CoinPackedMatrix * | quadraticObjective () const
| Quadratic objective. More...
double * | linearObjective () const
| Linear objective. More...
int | numberExtendedColumns () const
| Length of linear objective which could be bigger. More...
int | numberColumns () const
| Number of columns in quadratic objective. More...
bool | fullMatrix () const
| If a full or half matrix. More...
Public Member Functions inherited from ClpObjective
virtual void | newXValues ()
| Say we have new primal solution - so may need to recompute. More...
| ClpObjective ()
| Default Constructor. More...
| ClpObjective (const ClpObjective &)
| Copy constructor. More...
ClpObjective & | operator= (const ClpObjective &rhs)
| Assignment operator. More...
virtual | ~ClpObjective ()
| Destructor. More...
int | type () const
| Returns type (above 63 is extra information) More...
void | setType (int value)
| Sets type (above 63 is extra information) More...
int | activated () const
| Whether activated. More...
void | setActivated (int value)
| Set whether activated. More...
double | nonlinearOffset () const
| Objective offset. More...

## Private Attributes
Private member data
Quadratic objective
CoinPackedMatrix * | quadraticObjective_
| Objective. More...
double * | objective_
| Objective. More...
double * | gradient_
| Gradient. More...
int | numberColumns_
| Useful to have number of columns about. More...
int | numberExtendedColumns_
| Also length of linear objective which could be bigger. More...
bool | fullMatrix_
| True if full symmetric matrix, false if half. More...

## Additional Inherited Members
Protected Attributes inherited from ClpObjective
double | offset_
| Value of non-linear part of objective. More...
int | type_
| Type of objective - linear is 1. More...
int | activated_
| Whether activated. More...

## Detailed Description

Quadratic Objective Class.

Definition at line 18 of file ClpQuadraticObjective.hpp.

## Constructor & Destructor Documentation

ClpQuadraticObjective::ClpQuadraticObjective | ( |  | ) |

Default Constructor.

ClpQuadraticObjective::ClpQuadraticObjective | ( | const double * | linearObjective,
|  | int | numberColumns,
|  | const CoinBigIndex * | start,
|  | const int * | column,
|  | const double * | element,
|  | int | numberExtendedColumns_ = `-1`
| ) |  |

Constructor from objective.

ClpQuadraticObjective::ClpQuadraticObjective | ( | const ClpQuadraticObjective & | rhs,
|  | int | type = `0`
| ) |  |

Copy constructor .

If type is -1 then make sure half symmetric, if +1 then make sure full

ClpQuadraticObjective::ClpQuadraticObjective | ( | const ClpQuadraticObjective & | rhs,
|  | int | numberColumns,
|  | const int * | whichColumns
| ) |  |

Subset constructor.

Duplicates are allowed and order is as given.

virtual ClpQuadraticObjective::~ClpQuadraticObjective | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual double* ClpQuadraticObjective::gradient | ( | const ClpSimplex * | model,
|  | const double * | solution,
|  | double & | offset,
|  | bool | refresh,
|  | int | includeLinear = `2`
| ) |  |
| virtual

Returns gradient.

If Quadratic then solution may be NULL, also returns an offset (to be added to current one) If refresh is false then uses last solution Uses model for scaling includeLinear 0 - no, 1 as is, 2 as feasible

Implements ClpObjective.

virtual double ClpQuadraticObjective::reducedGradient | ( | ClpSimplex * | model,
|  | double * | region,
|  | bool | useFeasibleCosts
| ) |  |
| virtual

Resize objective.

Returns reduced gradient.Returns an offset (to be added to current one).

Implements ClpObjective.

virtual double ClpQuadraticObjective::stepLength | ( | ClpSimplex * | model,
|  | const double * | solution,
|  | const double * | change,
|  | double | maximumTheta,
|  | double & | currentObj,
|  | double & | predictedObj,
|  | double & | thetaObj
| ) |  |
| virtual

Returns step length which gives minimum of objective for solution + theta * change vector up to maximum theta.

arrays are numberColumns+numberRows Also sets current objective, predicted and at maximumTheta

Implements ClpObjective.

virtual double ClpQuadraticObjective::objectiveValue | ( | const ClpSimplex * | model,
|  | const double * | solution
| ) |  | const
| virtual

Return objective value (without any ClpModel offset) (model may be NULL)

Implements ClpObjective.

virtual void ClpQuadraticObjective::resize | ( | int | newNumberColumns | ) |
| virtual

Returns gradient.

If Quadratic then solution may be NULL, also returns an offset (to be added to current one) If refresh is false then uses last solution Uses model for scaling includeLinear 0 - no, 1 as is, 2 as feasible

Implements ClpObjective.

virtual void ClpQuadraticObjective::deleteSome | ( | int | numberToDelete,
|  | const int * | which
| ) |  |
| virtual

Delete columns in objective.

Implements ClpObjective.

virtual void ClpQuadraticObjective::reallyScale | ( | const double * | columnScale | ) |
| virtual

Scale objective.

Implements ClpObjective.

virtual int ClpQuadraticObjective::markNonlinear | ( | char * | which | ) |
| virtual

Given a zeroed array sets nonlinear columns to 1.

Returns number of nonlinear columns

Reimplemented from ClpObjective.

ClpQuadraticObjective& ClpQuadraticObjective::operator= | ( | const ClpQuadraticObjective & | rhs | ) |

Assignment operator.

virtual ClpObjective* ClpQuadraticObjective::clone | ( |  | ) | const
| virtual

Clone.

Implements ClpObjective.

virtual ClpObjective* ClpQuadraticObjective::subsetClone | ( | int | numberColumns,
|  | const int * | whichColumns
| ) |  | const
| virtual

Subset clone.

Duplicates are allowed and order is as given.

Reimplemented from ClpObjective.

void ClpQuadraticObjective::loadQuadraticObjective | ( | const int | numberColumns,
|  | const CoinBigIndex * | start,
|  | const int * | column,
|  | const double * | element,
|  | int | numberExtendedColumns = `-1`
| ) |  |

Load up quadratic objective.

This is stored as a CoinPackedMatrix

void ClpQuadraticObjective::loadQuadraticObjective | ( | const CoinPackedMatrix & | matrix | ) |

Default Constructor.

void ClpQuadraticObjective::deleteQuadraticObjective | ( |  | ) |

Get rid of quadratic objective.

CoinPackedMatrix* ClpQuadraticObjective::quadraticObjective | ( |  | ) | const
| inline

Quadratic objective.

Definition at line 115 of file ClpQuadraticObjective.hpp.

double* ClpQuadraticObjective::linearObjective | ( |  | ) | const
| inline

Linear objective.

Definition at line 119 of file ClpQuadraticObjective.hpp.

int ClpQuadraticObjective::numberExtendedColumns | ( |  | ) | const
| inline

Length of linear objective which could be bigger.

Definition at line 123 of file ClpQuadraticObjective.hpp.

int ClpQuadraticObjective::numberColumns | ( |  | ) | const
| inline

Number of columns in quadratic objective.

Definition at line 127 of file ClpQuadraticObjective.hpp.

bool ClpQuadraticObjective::fullMatrix | ( |  | ) | const
| inline

If a full or half matrix.

Definition at line 131 of file ClpQuadraticObjective.hpp.

## Member Data Documentation

CoinPackedMatrix* ClpQuadraticObjective::quadraticObjective_
| private

Objective.

Definition at line 141 of file ClpQuadraticObjective.hpp.

double* ClpQuadraticObjective::objective_
| private

Objective.

Definition at line 143 of file ClpQuadraticObjective.hpp.

double* ClpQuadraticObjective::gradient_
| private

Gradient.

Definition at line 145 of file ClpQuadraticObjective.hpp.

int ClpQuadraticObjective::numberColumns_
| private

Useful to have number of columns about.

Definition at line 147 of file ClpQuadraticObjective.hpp.

int ClpQuadraticObjective::numberExtendedColumns_
| private

Also length of linear objective which could be bigger.

Definition at line 149 of file ClpQuadraticObjective.hpp.

bool ClpQuadraticObjective::fullMatrix_
| private

True if full symmetric matrix, false if half.

Definition at line 151 of file ClpQuadraticObjective.hpp.

The documentation for this class was generated from the following file:

- /tmp/CHiPPS-Blis-0.94.3/Clp/src/ClpQuadraticObjective.hpp